function f = feature_norm_area(img, segm, pmap, roi, opt, debug)
% feature_norm_area - normalized segmentation area
%
%    f = feature_norm_area(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

f = sum(sum(segm.*roi.*pmap.pmapxy));

if (debug)
  figure
  subplot(2,2,1)
  imagesc(segm)
  subplot(2,2,2)
  imagesc(roi)
  subplot(2,2,3)
  imagesc(pmap.pmapxy);
  colorbar
  subplot(2,2,4)
  imagesc(segm.*roi.*pmap.pmapxy);
  title(sprintf('na=%g', f));
  colormap gray
end

