function f = feature_norm_edge(img, segm, pmap, roi, opt, debug)
% feature_norm_edge - normalized image edge length
%
%    f = feature_norm_edge(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

eimg  = edge(img, 'canny');
esegm = eimg.*(segm.*roi);

psegm = esegm.*pmap.sqrtpmapxy;

f = sum(sum(psegm));

if (debug)
  figure
  subplot(2,2,1)
  imagesc(img);
  colormap gray
  subplot(2,2,2)
  imagesc(eimg)
  subplot(2,2,3)
  imagesc(esegm)
  subplot(2,2,4)
  imagesc(esegm.*pmap.sqrtpmapxy);
  title(sprintf('ne=%g', f));
end
