function f = feature_norm_edgeminkowski(img, segm, pmap, roi, opt, debug)
% feature_norm_edgeminkowsi - normalized minkowski dimension of edges
%
%    f = feature_norm_edgeminkowski(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

eimg  = edge(img, 'canny');
esegm = eimg.*(segm.*roi);

f = getminkowski(esegm, pmap, debug);

if (debug)
  figure
  subplot(1,2,1)
  imagesc(img);
  subplot(1,2,2)
  imagesc(esegm)
  title(sprintf('nem=%g', f));
end
