function f = feature_norm_edgeorient(img, segm, pmap, roi, opt, debug)
% feature_norm_edgeorient - normalized edge orientation
%
%    f = feature_norm_edgeorient(img, segm, pmap, roi, opt, debug)
%
%    opt(1) = number of bins
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

eimg  = edge(img, 'canny');
esegm = eimg.*(segm.*roi);

psegm = esegm.*pmap.sqrtpmapxy;

f = getorientation(esegm, psegm, opt(1));

if (debug)
  figure
  subplot(2,2,1)
  imagesc(img);
  colormap gray
  subplot(2,2,2)
  imagesc(eimg)
  subplot(2,2,3)
  imagesc(esegm.*pmap.sqrtpmapxy);
  subplot(2,2,4)
  bar(f);
end
