function f = feature_norm_paratio(img, segm, pmap, roi, opt, debug)
% feature_norm_paratio - normalized perimeter/area ratio
%
%    f = feature_norm_paratio(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

se = strel([0 1 0;1 1 1;0 1 0]);

mysegm = double(segm) .* roi;
myedge = mysegm - imerode(mysegm, se);
p      = sum(sum(myedge.*pmap.sqrtpmapxy));
a      = sum(sum(mysegm.*pmap.pmapxy));

if (a==0)
  f = 0;
else
  f = p/a;
end

if (debug)
  figure
  subplot(2,2,1)
  imagesc(mysegm);
  subplot(2,2,2)
  imagesc(mysegm.*pmap.pmapxy);
  subplot(2,2,3)
  imagesc(myedge);
  subplot(2,2,4)
  imagesc(myedge.*pmap.sqrtpmapxy);
  title(sprintf('npa=%g', f));
  colormap gray
end
