function f = feature_norm_perimeter(img, segm, pmap, roi, opt, debug)
% feature_norm_perimeter - normalized perimeter length
%
%    f = feature_norm_perimeter(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

se = strel([0 1 0;1 1 1;0 1 0]);

mysegm = segm .* roi;
myedge = mysegm - imerode(mysegm, se);
f      = sum(sum(myedge.*pmap.sqrtpmapxy));

if (debug)
  figure
  subplot(2,2,1)
  imagesc(segm);
  subplot(2,2,2)
  imagesc(mysegm);
  subplot(2,2,3)
  imagesc(myedge);
  subplot(2,2,4)
  imagesc(myedge.*pmap.sqrtpmapxy);
  title(sprintf('np=%g', f));
  colormap gray
end
