function f = feature_norm_perimeterminkowski(img, segm, pmap, roi, opt, debug)
% feature_norm_perimeterminkowsi - normalized minkowski dimension of perimeter
%
%    f = feature_norm_perimeterminkowski(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

se = strel([0 1 0;1 1 1;0 1 0]);

mysegm = segm .* roi;
myedge = mysegm - imerode(mysegm, se);

f = getminkowski(myedge, pmap, debug);

if (debug)
  figure
  subplot(1,2,1)
  imagesc(img);
  subplot(1,2,2)
  imagesc(myedge)
  title(sprintf('npm=%g', f));
end
