function f = feature_norm_perimeterorient(img, segm, pmap, roi, opt, debug)
% feature_norm_perimeterorient - normalized perimeter orientation histogram
%
%    f = feature_norm_perimeterorient(img, segm, pmap, roi, opt, debug)
%
%    opt(1) = number of bins in histogram
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

if (all(segm(:) == 0))
  myedge = zeros(size(segm));
else 
  myedge = edge(double(segm),'canny').*roi;
end

f = getorientation(myedge, pmap.sqrtpmapxy.*myedge, opt(1));

if (debug)
  figure
  subplot(2,2,1)
  imagesc(segm);
  subplot(2,2,2)
  imagesc(myedge);
  subplot(2,2,3)
  imagesc(pmap.sqrtpmapxy.*myedge);
  subplot(2,2,4)
  bar(f);
  colormap gray
end
