function f = feature_numblobs(img, blobs, pmap, roi, opt, debug)
% feature_numblobs - number of blobs
%
%    f = feature_numblobs(img, blobs, pmap, roi, opt, debug)
%
%      opt = [];
%
% Copyright 2008, Antoni Chan, SVCL, UCSD


MINBLOBSIZE = 10;

% get number of blobs
maxj    = double(max(blobs(:)));

% mask with ROI
myblobs = double(blobs).*roi;

numblobs = 0;
for j=1:maxj
  % get blob
  jblob = (myblobs == j);
  
  % get area & normalized area
  tmp  = sum(sum(jblob));
  
  % if larger than minimum size, then remember
  if (tmp >= MINBLOBSIZE)
    numblobs = numblobs+1;
  end  
end

f = numblobs;


if (debug)
  figure
  subplot(2,2,1)
  imagesc(myblobs)
  title(sprintf('numblobs = %d', numblobs));
end

