function f = feature_paratio(img, segm, pmap, roi, opt, debug)
% feature_paratio - perimeter/area ratio
%
%    f = feature_paratio(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

se = strel([0 1 0;1 1 1;0 1 0]);

mysegm = double(segm) .* roi;
myedge = mysegm - imerode(mysegm, se);
p      = sum(sum(myedge));
a      = sum(sum(mysegm));

if (a == 0)
  f = 0;
else
  f = p/a;
end

if (debug)
  figure
  subplot(1,2,1)
  imagesc(mysegm);
  subplot(1,2,2)
  imagesc(myedge);
  title(sprintf('pa=%g', f));
  colormap gray
end
