function f = feature_roundness(img, segm, pmap, roi, opt, debug)
% feature_roundness - roundness
%
%    f = feature_roundness(img, segm, pmap, roi, opt, debug)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

se = strel([0 1 0;1 1 1;0 1 0]);

mysegm = double(segm) .* roi;
myedge = mysegm - imerode(mysegm, se);
p      = sum(sum(myedge));
a      = sum(sum(mysegm));

f = a/(p^2);

if (debug)
  figure
  subplot(1,2,1)
  imagesc(mysegm);
  subplot(1,2,2)
  imagesc(myedge);
  title(sprintf('r=%g', f));
  colormap gray
end
