function bmaskii = mask2border(mask, bordersize)
% mask2border - make a border image from a segmentation mask
%
%    bmask = mask2border(mask, bordersize)
%
%    bordersize = width of border (default=2)
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

% versions: 2008-04-07 - updated bordersize=1 filter
%           2009-10-20 - fixed to work with MATLAB 6

if bordersize == 1
  d = strel('square', 2);
else
  d = strel('disk', bordersize)
end
  
mm    = double(max(mask(:)));
minm  = double(min(mask(:)));

myclass = class(mask);

bmaskii = [];
for j=minm:mm
  jj = feval(myclass, j);    % convert to same class as mask
  tmp = (mask==jj);
  ii = find(tmp ~= imdilate(tmp, d));
  bmaskii = [bmaskii; ii];
end
