function peoplecnt_cmd(mode, optfile)
% peoplecnt_cmd - command line interface for peoplecnt
%
%    peoplecnt_cmd(mode, optfile)
%
%    mode    - 'feature', 'train', 'predict', 'eval'
%    optfile - option file name
%
%  see peoplecnt for a description of the options.
%
% Copyright 2008, Antoni Chan, SVCL, UCSD
if (nargin~=2)
  fprintf('usage: peoplecnt_cmd <mode> <optfile>\n\n');
  error('wrong number of arguments');
end

fprintf('reading option file: %s\n', optfile);

% read the option file
fid = fopen(optfile, 'r');
if (fid == -1)
  error('could not open file!');
end
while 1
  tline = fgetl(fid);
  if ~ischar(tline), break, end
  fprintf(': %s\n', tline);
  eval(tline);
end
fclose(fid);

% set mode
opt.mode = mode;

% set other options
opt.debug       = 0;
opt.flag_nogz   = 1;  % don't gzip mat files
opt.flag_usemat = 1;  % use mat files for image inputs

% run peoplecnt
peoplecnt(opt);


%%% add manual dependencies

%#function covConst covLINard covLINone covMatern3iso covMatern5iso
%#function covNNone covNoise covPeriodic covProd covRQard covRQiso
%#function covSEard covSEiso covSum

