function [cgt] = peoplecnt_loadgt(opt)
% peoplecnt_loadgt - load the ground-truth
%
%    [cgt] = peoplecnt_loadgt(opt)
%
%        opt - options
%     cgt{i} - the groundtruth for image i
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

%%% load the ground-truth %%%%%%%%%%
fprintf('loading ground-truth:\n');
cgt = cell(1,length(opt.imgnames));
for i=1:length(opt.truthname)
  mycgtname = opt.truthname{i};
  fprintf('    %d: %s\n', i, mycgtname);	  
  if ~isempty(mycgtname)
    tmp = load(mycgtname);
    cgt{i} = tmp.cgt;
  else
    cgt{i} = [];
  end
end
