function [opt] = peoplecntgui_defaultproject()

% base directory for the experiment
opt.basedir     = '';

% set to 1, to force recomputing everything (i.e. do not use cached values)
opt.recompute   = 0;

% the region of interest file
opt.roiname     = '';

% the perspective map file
opt.pmapname    = '';

% the segmentation map file
opt.segmmapname = '';

% the directions 
opt.dirs        = {};   

% the video files
opt.imgnames     = {};

% the segmentation files
opt.segmnames    = {};
  
% file prefix for saving features
opt.featpref     = {};
opt.featsuf      = 'feat';
 
% the ground truth files
opt.truthname    = {};

% evaluation set file
opt.evalname = '';

% the index of the evaluation set to use
opt.evalnum  = [1];

% file prefix for saving models
opt.modelpref     = ['models' filesep 'model1'];

% file prefix for saving predictions
opt.predpref   = {};
opt.predsuf    = 'pred1';

% file prefix for saving model evaluation
opt.evalpref      = ['results' filesep 'eval1'];

% the feature set
opt.feature{1}.name = 'norm_area';            
opt.feature{1}.opt = [];  
opt.feature{1}.sub = [];
opt.feature{2}.name = 'norm_perimeter';      
opt.feature{2}.opt = [];  
opt.feature{2}.sub = [];
opt.feature{3}.name = 'norm_perimeterorient'; 
opt.feature{3}.opt = 6;   
opt.feature{3}.sub = [];
opt.feature{4}.name = 'norm_paratio';         
opt.feature{4}.opt = [];  
opt.feature{4}.sub = [];
opt.feature{5}.name = 'norm_edge';            
opt.feature{5}.opt = [];  
opt.feature{5}.sub = [];
opt.feature{6}.name = 'norm_edgeorient';      
opt.feature{6}.opt = 6;   
opt.feature{6}.sub = [];
opt.feature{7}.name = 'norm_edgeminkowski';   
opt.feature{7}.opt = [];  
opt.feature{7}.sub = [];
opt.feature{8}.name = 'norm_glcm';           
opt.feature{8}.opt = 'f'; 
opt.feature{8}.sub = [3 4 5,8 9 10,13 14 15,18 19 20];

% regression model parameters
opt.model.name            = 'gp';
opt.model.param.covfunc   = {'covSum',{'covSEiso_fast','covLINone','covNoise'}};
%opt.model.param.covfunc   = {'covSum',{'covSEiso','covLINone','covNoise'}};
opt.model.param.normmode  = 'y';
opt.model.param.numtrials = 1;
opt.model.norm            = 'X';
opt.model.namesuf         = 'gp-lin-rbf';

