function varargout = peoplecntgui_modelset(varargin)
% PEOPLECNTGUI_MODELSET M-file for peoplecntgui_modelset.fig
%      PEOPLECNTGUI_MODELSET, by itself, creates a new PEOPLECNTGUI_MODELSET or raises the existing
%      singleton*.
%
%      H = PEOPLECNTGUI_MODELSET returns the handle to a new PEOPLECNTGUI_MODELSET or the handle to
%      the existing singleton*.
%
%      PEOPLECNTGUI_MODELSET('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PEOPLECNTGUI_MODELSET.M with the given input arguments.
%
%      PEOPLECNTGUI_MODELSET('Property','Value',...) creates a new PEOPLECNTGUI_MODELSET or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before peoplecntgui_modelset_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to peoplecntgui_modelset_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help peoplecntgui_modelset

% Last Modified by GUIDE v2.5 06-Feb-2009 12:09:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @peoplecntgui_modelset_OpeningFcn, ...
                   'gui_OutputFcn',  @peoplecntgui_modelset_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before peoplecntgui_modelset is made visible.
function peoplecntgui_modelset_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to peoplecntgui_modelset (see VARARGIN)

% Choose default command line output for peoplecntgui_modelset
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes peoplecntgui_modelset wait for user response (see UIRESUME)
% uiwait(handles.figure1);
global G_MODELSET
set_model(G_MODELSET, handles);


% --- Outputs from this function are returned to the command line.
function varargout = peoplecntgui_modelset_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_okay.
function pushbutton_okay_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_okay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_MODELSET
fprintf('setting regression model.\n');
G_MODELSET = get_model(handles);
closereq;

% --- Executes on button press in pushbutton_cancel.
function pushbutton_cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_MODELSET

G_MODELSET = [];
closereq;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% set GUI with model
function set_model(G_MODELSET, handles)
if ~isfield(G_MODELSET, 'namesuf')
  G_MODELSET.namesuf = 'gp-lin-rbf';
end

switch(G_MODELSET.namesuf)
  case 'lin'
    set(handles.uipanel_regress, 'SelectedObject', handles.radiobutton_linear)
  case 'roblin'
    set(handles.uipanel_regress, 'SelectedObject', handles.radiobutton_roblin)
  case 'gp-lin'
    set(handles.uipanel_regress, 'SelectedObject', handles.radiobutton_gplin)
  case 'gp-lin-rbf'
    set(handles.uipanel_regress, 'SelectedObject', handles.radiobutton_gplinrbf)
  case 'gp-rbf-rbf'
    set(handles.uipanel_regress, 'SelectedObject', handles.radiobutton_gprbfrbf)
    
  otherwise
    fprintf('ERROR: bad model name');
end
    


% get model name from GUI
function model = get_model(handles)
model = [];
tmpname = get(get(handles.uipanel_regress, 'SelectedObject'), 'Tag');
switch(tmpname)
  case 'radiobutton_linear'
    model.name            = 'lin';
    model.param           = [];
    model.norm            = 'X';
    model.namesuf         = 'lin';

  case 'radiobutton_roblin'
    model.name            = 'rob';
    model.param           = [];
    model.norm            = 'X';
    model.namesuf         = 'roblin';

  case 'radiobutton_gplin'
    model.name            = 'gp';
    model.param.covfunc   = {'covSum',{'covLINone','covNoise'}};
    model.param.normmode  = 'y';
    model.param.numtrials = 1;
    model.norm            = 'X';
    model.namesuf         = 'gp-lin';
    
  case 'radiobutton_gplinrbf'
    model.name            = 'gp';
    %model.param.covfunc   = {'covSum',{'covSEiso','covLINone','covNoise'}};
    model.param.covfunc   = {'covSum',{'covSEiso_fast','covLINone','covNoise'}};
    model.param.normmode  = 'y';
    model.param.numtrials = 1;
    model.norm            = 'X';
    model.namesuf         = 'gp-lin-rbf';
    
  case 'radiobutton_gprbfrbf'
    model.name            = 'gp';
    %model.param.covfunc   = {'covSum',{'covSEiso','covSEiso','covNoise'}};
    model.param.covfunc   = {'covSum',{'covSEiso_fast','covSEiso_fast2','covNoise'}};
    model.param.normmode  = '';
    model.param.numtrials = 5;
    model.norm            = 'X';
    model.namesuf         = 'gp-rbf-rbf';
    
  otherwise
    fprintf('ERROR: bad model selection!');
end
  





