function peoplecntgui_saveproject(opt, fname)

% BUG FIX - 2009/04/10 - fixed when saving strings

myfname = [opt.basedir filesep fname];
fprintf('saving project file [%s]...', myfname);
fid = fopen(myfname, 'w');

fprintf(fid, '%% Project file automatically generated by peoplecntgui v1.01\r\n\r\n');

fprintf(fid, '%% base directory for the experiment\r\n');
fprintf(fid, 'opt.basedir     = ''%s'';\r\n\r\n', opt.basedir);

fprintf(fid, '%% set to 1, to force recomputing everything (i.e. do not use cached values)\r\n');
fprintf(fid, 'opt.recompute   = 0;\r\n\r\n');

fprintf(fid, '%% the region of interest file\r\n');
fprintf(fid, 'opt.roiname     = ''%s'';\r\n\r\n', opt.roiname);

fprintf(fid, '%% the perspective map file\r\n');
fprintf(fid, 'opt.pmapname    = ''%s'';\r\n\r\n', opt.pmapname);

fprintf(fid, '%% the segmentation map file\r\n');
fprintf(fid, 'opt.segmmapname = ''%s'';\r\n\r\n', opt.segmmapname);

fprintf(fid, '%% the directions\r\n');
fprintf(fid, 'opt.dirs        = %s;\r\n\r\n', cell2str(opt.dirs));

fprintf(fid, '%% the video files\r\n');
if isempty(opt.imgnames)
  fprintf(fid, 'opt.imgnames = {};\r\n\r\n');
else
  for i=1:length(opt.imgnames)
    fprintf(fid, 'opt.imgnames{%d} = ''%s'';\r\n', i, opt.imgnames{i});
  end
  fprintf(fid, '\r\n');
end

fprintf(fid, '%% the segmentation files\r\n');
if isempty(opt.segmnames)
  fprintf(fid, 'opt.segmnames = {};\r\n\r\n');
else
  for i=1:length(opt.segmnames)
    fprintf(fid, 'opt.segmnames{%d} = ''%s'';\r\n', i, opt.segmnames{i});
  end
  fprintf(fid, '\r\n');
end

fprintf(fid, '%% file prefix for saving features\r\n');
if isempty(opt.featpref)
  fprintf(fid, 'opt.featpref = {};\r\n');
else
  for i=1:length(opt.featpref)
    fprintf(fid, 'opt.featpref{%d} = ''%s'';\r\n', i, opt.featpref{i});
  end
end
fprintf(fid, 'opt.featsuf      = ''%s'';\r\n\r\n', opt.featsuf);

fprintf(fid, '%% the ground truth files\r\n');
if isempty(opt.truthname)
  fprintf(fid, 'opt.truthname = {};\r\n\r\n');
else
  for i=1:length(opt.truthname)
    fprintf(fid, 'opt.truthname{%d} = ''%s'';\r\n', i, opt.truthname{i});
  end
  fprintf(fid, '\r\n');
end

fprintf(fid, '%% evaluation set file\r\n');
fprintf(fid, 'opt.evalname = ''%s'';\r\n\r\n', opt.evalname);

fprintf(fid, '%% the index of the evaluation set to use\r\n');
fprintf(fid, 'opt.evalnum  = %s;\r\n\r\n', mat2str(opt.evalnum));

fprintf(fid, '%% file prefix for saving models\r\n');
fprintf(fid, 'opt.modelpref     = ''%s'';\r\n\r\n', opt.modelpref);

fprintf(fid, '%% file prefix for saving predictions\r\n');
if isempty(opt.predpref)
  fprintf(fid, 'opt.predpref = {};\r\n');
else
  for i=1:length(opt.predpref)
    fprintf(fid, 'opt.predpref{%d} = ''%s'';\r\n', i, opt.predpref{i});
  end
end
fprintf(fid, 'opt.predsuf      = ''%s'';\r\n\r\n', opt.predsuf);

fprintf(fid, '%% file prefix for saving model evaluation\r\n');
fprintf(fid, 'opt.evalpref      = ''%s'';\r\n\r\n', opt.evalpref);

fprintf(fid, '%% the feature set\r\n');
for i=1:length(opt.feature)
  fprintf(fid, 'opt.feature{%d}.name = ''%s'';\r\n', i, opt.feature{i}.name);
  if (ischar(opt.feature{i}.opt))
    fprintf(fid, 'opt.feature{%d}.opt = ''%s'';\r\n', i, opt.feature{i}.opt);
  else
    fprintf(fid, 'opt.feature{%d}.opt = %s;\r\n', i, mat2str(opt.feature{i}.opt));
  end
  fprintf(fid, 'opt.feature{%d}.sub = %s;\r\n', i, mat2str(opt.feature{i}.sub));
end
fprintf(fid, '\r\n');

fprintf(fid, '% regression model parameters\r\n');
fprintf(fid, 'opt.model.name            = ''%s'';\r\n', opt.model.name);
fprintf(fid, 'opt.model.namesuf         = ''%s'';\r\n', opt.model.namesuf);
fprintf(fid, 'opt.model.norm            = ''%s'';\r\n', opt.model.norm);
switch(opt.model.name)
  case 'gp'
    fprintf(fid, 'opt.model.param.covfunc   = %s;\r\n', cell2str(opt.model.param.covfunc));
    fprintf(fid, 'opt.model.param.normmode  = ''%s'';\r\n', opt.model.param.normmode);
    fprintf(fid, 'opt.model.param.numtrials = %d;\r\n', opt.model.param.numtrials);
  case {'lin', 'rob'}
    fprintf(fid, 'opt.model.param   = [];\r\n');
  otherwise
    error('could not save model parameters!');
end
fprintf(fid, '\r\n');
fclose(fid);

fprintf('done.\n');

function s = cell2str(c)
if isempty(c)
  s = '{}';
else
  s = '{';
  for i=1:length(c)
    if (i>1)
      s = [s ', '];
    end
    if iscell(c{i})
      s = [s cell2str(c{i})];
    else
      s = [s sprintf('''%s''', c{i})];
    end
  end
  s = [s '}'];
end
