function varargout = peoplecntgui_viewer(varargin)

%% BUG FIX: 2009-04-13: fill in remaining frames


% global variables for calling viewer:
%
%  G_VIEWER.fps  = framerate
%  G_VIEWER.img  = image
%  G_VIEWER.roi  = roi
%  G_VIEWER.segm = segm
%  G_VIEWER.mode = 'view', 'roi', 'pmap', 'segm', 'truth', 
%  G_VIEWER.output
%  G_VIEWER.title = title
%          .truth
%          .pred
%          .pmapview

% internal variables
%
% G_VIEWER_INT.cimg
%             .is_playing
%             .viewtoggle
%             .numframes

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @peoplecntgui_viewer_OpeningFcn, ...
                   'gui_OutputFcn',  @peoplecntgui_viewer_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before makegt is made visible.
function peoplecntgui_viewer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to makegt (see VARARGIN)

% Choose default command line output for makegt
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes makegt wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%%% initialize variables %%%
global G_VIEWER G_VIEWER_INT G_OPT

G_VIEWER.output = [];
if ~isfield(G_VIEWER, 'roi')
  G_VIEWER.roi = [];
end
if ~isfield(G_VIEWER, 'segm')
  G_VIEWER.segm = [];
end
if ~isfield(G_VIEWER, 'title')
  G_VIEWER.title = [];
end
if ~isfield(G_VIEWER, 'truth')
  G_VIEWER.truth = [];
end
if ~isfield(G_VIEWER, 'pred')
  G_VIEWER.pred = [];
end
G_VIEWER_INT.is_playing = 0;
G_VIEWER_INT.cimg = [];
G_VIEWER_INT.numframes = size(G_VIEWER.img,3);
G_VIEWER_INT.pmap = [];
G_VIEWER_INT.viewtoggle = [1 1 1 1];
if (isempty(G_VIEWER.roi))
  G_VIEWER_INT.viewtoggle(1) = -1;
end
if (isempty(G_VIEWER.segm))
  G_VIEWER_INT.viewtoggle(2) = -1;
end
if (isempty(G_VIEWER.truth))
  G_VIEWER_INT.viewtoggle(3) = -1;
end
if (isempty(G_VIEWER.pred))
  G_VIEWER_INT.viewtoggle(4) = -1;
end

% setup slider
set(handles.slider_frame, 'Min', 1);
set(handles.slider_frame, 'Max', G_VIEWER_INT.numframes);
if strcmp(G_VIEWER.mode, 'truth')
  G_VIEWER_INT.minstep = [5 5];
  G_VIEWER_INT.startframe = 3;
else
  G_VIEWER_INT.minstep = [1 5];
  G_VIEWER_INT.startframe = 1;
end
set(handles.slider_frame, 'Value', G_VIEWER_INT.startframe);
set(handles.slider_frame, 'SliderStep', G_VIEWER_INT.minstep/(G_VIEWER_INT.numframes-1));

% setup mode
switch(G_VIEWER.mode)
  %%% normal view %%%%
  case 'view'
    set(handles.button_multi1, 'Visible', 'off'); 
    set(handles.button_multi2, 'Visible', 'off');
    set(handles.button_multi3, 'Visible', 'off');
    set(handles.button_multi4, 'Visible', 'off');
    set(handles.panel_mode, 'Title', 'Info');
    set(handles.text_info, 'String', '');
    mytitle = 'Image Viewer';
    mypointer = 'arrow';
    
    % setup segmentation legend
    if ~isempty(G_VIEWER.segm)
      legcolors = {'pink', 'green', 'purple', 'yellow', ...
        'magenta', 'cyan', 'red', 'green', 'blue', 'white'};
      tmpstr = {'--- Segmentation Legend ---'};
      tmp = load(G_OPT.segmmapname);
      for i=1:length(tmp.segmmap)
        tmpstr{end+1} = ['Class ' tmp.segmmap{i} ' = ' legcolors{i}];
      end
      G_VIEWER_INT.segmleg = tmpstr;
    end
    
    
  %%% define ROI %%%%
  case 'roi'
    set(handles.button_multi1, 'Visible', 'on');  
    set(handles.button_multi1, 'String', 'Mark ROI');
    set(handles.button_cancel, 'Visible', 'on');    
    set(handles.panel_mode, 'Title', 'Instructions');
    instructions = {'1) press "mark ROI" button', ...
      '2) click on image to add vertices', ...
      '3) shift-click to add final vertex, or press ''enter'' key to finish without adding vertex'};
    set(handles.text_info, 'String', instructions);
    mytitle = 'Mark ROI';
    mypointer = 'arrow';
  %%% define Pmap %%%%
  case 'pmap'
    set(handles.button_multi1, 'Visible', 'on');  
    set(handles.button_multi2, 'Visible', 'on');  
    set(handles.button_multi3, 'Visible', 'on');      
    set(handles.button_multi4, 'Visible', 'on');      
    set(handles.button_multi1, 'String', 'Mark Groundplane');
    set(handles.button_multi2, 'String', 'Mark Near Reference');
    set(handles.button_multi3, 'String', 'Mark Far Reference');   
    set(handles.button_multi4, 'String', 'View Perspective Map');   
    set(handles.button_cancel, 'Visible', 'on');    
    set(handles.panel_mode, 'Title', 'Instructions');
    instructions = {'1) press "mark Groundplane", and mark 4 corners of ground plane', ...
      '2) find a reference person that is centered on the top and bottom lines of the ground-plane', ...
      '3) press "mark Near Reference", and mark a box around the near reference', ...
      '4) press "mark Far Reference", and mark a box around the far reference', ...
      '5) click "View perspective Map" to check the map', ...
      'Hints: click on image to add vertices.  shift-click to add final vertex, or press ''enter'' key to finish without adding vertex'};
    set(handles.text_info, 'String', instructions);
    mytitle = 'Make Perspective Map';
    mypointer = 'arrow';
    G_VIEWER_INT.pmap.gndbox  = [];
    G_VIEWER_INT.pmap.nearbox = [];
    G_VIEWER_INT.pmap.farbox  = [];
    G_VIEWER_INT.pmap.pmapxy  = [];
    G_VIEWER_INT.pmap.pmapx   = [];
    G_VIEWER_INT.pmap.pmapy   = [];
  %%% view Pmap %%%%
  case 'pmapview'
    set(handles.button_multi4, 'Visible', 'on');      
    set(handles.button_multi4, 'String', 'View Perspective Map');   
    set(handles.button_cancel, 'Visible', 'on');    
    set(handles.panel_mode, 'Title', 'Instructions');
    instructions = {'view perspective map'};
    set(handles.text_info, 'String', instructions);
    mytitle = 'View Perspective Map';
    mypointer = 'arrow';
    G_VIEWER_INT.pmap = G_VIEWER.pmapview;
  %%% map segmentation %%%
  case 'segm'
    set(handles.button_multi2, 'Visible', 'on');  
    set(handles.button_multi3, 'Visible', 'on');  
    set(handles.button_multi2, 'String', 'Next Segment');
    set(handles.button_multi3, 'String', 'Previous Segment');
    set(handles.button_cancel, 'Visible', 'on');    
    set(handles.panel_mode, 'Title', 'Instructions');
    mytitle = 'Check Segmentation';
    mypointer = 'arrow';

    % setup segm
    tmp = load(G_OPT.segmmapname);
    tmpval = unique(G_VIEWER.segm(:));
    tmpval = tmpval(find(tmpval~=0));
    
    G_VIEWER_INT.segm.segmold = G_VIEWER.segm;
    G_VIEWER_INT.segm.segmmap = tmp.segmmap;
    G_VIEWER_INT.segm.cur = 1;
    G_VIEWER_INT.segm.map = [tmpval, zeros(length(tmpval),1)];
    G_VIEWER_INT.segm.len = length(tmpval);
    G_VIEWER.segm = [];
    
    tmpstr{1} = '-';
    for i=1:length(tmp.segmmap)
      tmpstr{i+1} = ['Class ' tmp.segmmap{i}];
    end
    set(handles.popup_multi5, 'Visible', 'on');
    set(handles.popup_multi5, 'String', tmpstr);
    updateSegmMap(handles, 0);
    
  %%% mark truth %%%
  case 'truth'
    set(handles.button_multi2, 'Visible', 'on');
    set(handles.button_multi3, 'Visible', 'on');  
    set(handles.button_multi4, 'Visible', 'on');
    set(handles.button_multi2, 'String', 'Undo');
    set(handles.button_multi3, 'String', 'Clear Frame');
    set(handles.button_multi4, 'String', 'Use Previous Frame');
    set(handles.button_cancel, 'Visible', 'on');    
    set(handles.panel_mode, 'Title', 'Instructions');
    mytitle = 'Count People';
    mypointer = 'crosshair';
    
    tmpstr = {};
    for i=1:length(G_OPT.dirs)
      tmpstr{i} = ['Class ' G_OPT.dirs{i}];
    end
    set(handles.popup_multi5, 'Visible', 'on');
    set(handles.popup_multi5, 'String', tmpstr);
    
    % initialize variables
    G_VIEWER_INT.rawlocs = cell(length(G_OPT.dirs),G_VIEWER_INT.numframes);
    updateTruthText(handles);
    
  otherwise
    error('bad viewer mode');
end

% set title
if ~isempty(G_VIEWER.title)
  mytitle = [mytitle ' - ' G_VIEWER.title];
end
set(handles.figure1, 'Name', mytitle);
set(handles.figure1, 'Pointer', mypointer);

% setup view toggle
updateViewToggle(handles);

% draw
make_image(handles);
incrementFrame(handles, 0);

% --- Outputs from this function are returned to the command line.
function varargout = peoplecntgui_viewer_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1
%draw_image;


function axes1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


function image_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
global G_VIEWER G_VIEWER_INT
switch(G_VIEWER.mode)
  case 'truth'
    pt = get(gca, 'CurrentPoint'); % [x, y]
    updateTruth(handles, 'add', [pt(1,2) pt(1,1)]);
end


% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER_INT
mykey = get(gcf, 'CurrentCharacter');
switch(mykey)
  case '.', incrementFrame(handles, G_VIEWER_INT.minstep(1));
  case ',', incrementFrame(handles, -G_VIEWER_INT.minstep(1));
  case '/', incrementFrame(handles, G_VIEWER_INT.minstep(2));
  case 'm', incrementFrame(handles, -G_VIEWER_INT.minstep(2));
end

% --- Executes on slider movement.
function slider_frame_Callback(hObject, eventdata, handles)
% hObject    handle to slider_frame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
incrementFrame(handles, 0);

% --- Executes during object creation, after setting all properties.
function slider_frame_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_frame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on button press in button_play.
function button_play_Callback(hObject, eventdata, handles)
% hObject    handle to button_play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER G_VIEWER_INT

if (G_VIEWER_INT.is_playing == 1)
  G_VIEWER_INT.is_playing = 0;
  set(hObject, 'String', 'Play');
else
  G_VIEWER_INT.is_playing = 1;
  set(hObject, 'String', 'Stop');
  mytime = (1.0/G_VIEWER.fps);
  % Plays the video
  etime = 0;
  while(1)
    % If stop button was pressed, exit loop
    if G_VIEWER_INT.is_playing == 0
      break;
    end
    tic;
    incrementFrame(handles, G_VIEWER_INT.minstep(1));
    etime = toc;
    if (etime <mytime)
      pause(mytime-etime);
    else
      drawnow;
    end   
  end
end

% --- Executes on button press in popup_viewtoggle.
function popup_viewtoggle_Callback(hObject, eventdata, handles)
% hObject    handle to button_play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER_INT
v = get(hObject, 'Value')-1;
if (v ~= 0)
  if (G_VIEWER_INT.viewtoggle(v) ~= -1)
    G_VIEWER_INT.viewtoggle(v) = ~G_VIEWER_INT.viewtoggle(v);
  end
end
updateViewToggle(handles);
% update image
if any(v==[1 2])
  make_image(handles);
  draw_image(handles);
end

% --- Executes on button press in button_multi1.
function button_multi1_Callback(hObject, eventdata, handles)
% hObject    handle to button_multi1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER
switch(G_VIEWER.mode)
  case 'roi'
    markroi(handles);
  case 'pmap'
    markpmap(handles, 'gndbox')
end

% --- Executes on button press in button_multi2.
function button_multi2_Callback(hObject, eventdata, handles)
% hObject    handle to button_multi2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER
switch(G_VIEWER.mode)
  case 'pmap'
    markpmap(handles, 'nearbox')
  case 'segm'
    updateSegmMap(handles, 1);
    make_image(handles);
    draw_image(handles);    
  case 'truth'
    updateTruth(handles, 'undo');    
end

% --- Executes on button press in button_multi3.
function button_multi3_Callback(hObject, eventdata, handles)
% hObject    handle to button_multi3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER
switch(G_VIEWER.mode)
  case 'pmap'
    markpmap(handles, 'farbox')
  case 'segm'
    updateSegmMap(handles, -1);
    make_image(handles);
    draw_image(handles);
  case 'truth'
    updateTruth(handles, 'clear');
end

% --- Executes on button press in button_multi4.
function button_multi4_Callback(hObject, eventdata, handles)
% hObject    handle to button_multi4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER
switch(G_VIEWER.mode)
  case {'pmap', 'pmapview'}
    markpmap(handles, 'view');
  case 'truth'
    updateTruth(handles, 'copy');
end

% --- Executes on button press in popup_multi5.
function popup_multi5_Callback(hObject, eventdata, handles)
% hObject    handle to button_play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER G_VIEWER_INT
switch(G_VIEWER.mode)
  case 'segm'
    i = G_VIEWER_INT.segm.cur;
    G_VIEWER_INT.segm.map(i,2) = get(hObject, 'Value')-1;
    updateSegmText(handles);
end

% --- Executes on button press in button_cancel.
function button_cancel_Callback(hObject, eventdata, handles)
% hObject    handle to button_cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER
G_VIEWER.output = [];
doclose();

% --- Executes on button press in button_okay.
function button_okay_Callback(hObject, eventdata, handles)
% hObject    handle to button_okay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global G_VIEWER
switch (G_VIEWER.mode)
  case 'segm'
    outputSegmMap();
  case 'truth'
    outputTruth();
end
doclose();


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% IMAGE FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function updateViewToggle(handles)
global G_VIEWER_INT
tmpstr = {'View', 'ROI', 'Segm', 'Truth', 'Pred'};
foo = {'(none)', '(off)', '(on)'};
for i=1:4
  tmpstr{i+1} = [tmpstr{i+1} ' ' foo{G_VIEWER_INT.viewtoggle(i)+2}];
end
set(handles.popup_viewtoggle, 'String', tmpstr);
set(handles.popup_viewtoggle, 'Value', 1);

function make_image(handles)
global G_VIEWER_INT G_VIEWER
oldpointer = get(handles.figure1, 'Pointer');
set(handles.figure1,'Pointer','watch');
drawnow
fprintf('processing video...');
tmpimg = G_VIEWER.img;
tmpsize = size(tmpimg,1)*size(tmpimg,2);
% add ROI
if G_VIEWER_INT.viewtoggle(1) && ~isempty(G_VIEWER.roi)
  fprintf('roi...');
  ii = find(G_VIEWER.roi==0);
  for i=1:G_VIEWER_INT.numframes
    iii = ii + (i-1)*tmpsize;
    tmpimg(iii) = uint8(tmpimg(iii)/2);
  end
end
% add segmentation mask
if G_VIEWER_INT.viewtoggle(2) && ~isempty(G_VIEWER.segm)
  fprintf('segm...');
  G_VIEWER_INT.cimg = colormask(tmpimg, G_VIEWER.segm, 1);
else
  G_VIEWER_INT.cimg = gray2rgbm(tmpimg);
end
fprintf('done.\n');
set(handles.figure1,'Pointer',oldpointer);
drawnow


% draw image
function draw_image(handles)
global G_VIEWER G_VIEWER_INT G_OPT
figure(handles.figure1); % select this figure
frame = get(handles.slider_frame, 'Value');
h = image(G_VIEWER_INT.cimg(:,:,:,frame));
%set(h, 'ButtonDownFcn', @image_ButtonDownFcn);
set(h, 'ButtonDownFcn', ...
  'peoplecntgui_viewer(''image_ButtonDownFcn'',gcbo,[],guidata(gcbo))');

%colormap(gray(256))
axis image
axisremove
title(sprintf('frame %d/%d', frame, G_VIEWER_INT.numframes));

switch(G_VIEWER.mode)
  % draw perspective map
  case {'pmap', 'pmapview'}      
    hold on
    if ~isempty(G_VIEWER_INT.pmap.gndbox)
      yy = G_VIEWER_INT.pmap.gndbox(:,1);
      xx = G_VIEWER_INT.pmap.gndbox(:,2);
      yy(end+1) = yy(1);
      xx(end+1) = xx(1);
      plot(xx, yy, '.r-');
    end
    if ~isempty(G_VIEWER_INT.pmap.farbox)
      yy = G_VIEWER_INT.pmap.farbox(:,1);
      xx = G_VIEWER_INT.pmap.farbox(:,2);
      plot(xx, yy, 'r');
    end
    if ~isempty(G_VIEWER_INT.pmap.nearbox)
      yy = G_VIEWER_INT.pmap.nearbox(:,1);
      xx = G_VIEWER_INT.pmap.nearbox(:,2);
      plot(xx, yy, 'r');
    end
    hold off
  % draw truth
  case 'truth'
    marks = {'rx', 'ro', 'rs', 'r<', 'r>', 'r^'};
    for j=1:size(G_VIEWER_INT.rawlocs,1)
      if ~isempty(G_VIEWER_INT.rawlocs{j,frame})
        hold on
        plot(G_VIEWER_INT.rawlocs{j,frame}(:,2), ...
          G_VIEWER_INT.rawlocs{j,frame}(:,1), marks{j});
        hold off
      end
    end
    % draw ROI box
  case 'roi'
    if ~isempty(G_VIEWER.output)
      hold on
      plot(G_VIEWER.output.xi, G_VIEWER.output.yi, 'r.-');
      hold off
    end
end

drawnow

% increment frame, and draw image
function incrementFrame(handles, incr)
global G_VIEWER_INT G_VIEWER
if ~ishandle(handles.slider_frame)
  return
end
frame = get(handles.slider_frame, 'Value');
ms = G_VIEWER_INT.minstep(1);
sf = G_VIEWER_INT.startframe;

% just check frame number
if (incr == 0)
  frame = fix((frame-sf)/ms)*ms+sf;

else
  % increment frame
  frame = frame+incr;
  if (frame > G_VIEWER_INT.numframes)
    frame = G_VIEWER_INT.startframe;
  end
  if (frame < 1)
    frame = floor((G_VIEWER_INT.numframes-sf)/ms)*ms+sf;
  end
end
  
% update slider, and draw
if ~ishandle(handles.slider_frame)
  return
end
set(handles.slider_frame, 'Value', round(frame));
draw_image(handles);
switch(G_VIEWER.mode)
  case 'truth'
    updateTruthText(handles);
  case 'view'
    updateViewText(handles);
end

function updateViewText(handles)
global G_VIEWER G_OPT G_VIEWER_INT

str = {};

if ~isempty(G_VIEWER.segm)
  str = G_VIEWER_INT.segmleg;
  str{end+1} = '';
end

if ~isempty(G_VIEWER.truth) || ~isempty(G_VIEWER.pred)
  if ~ishandle(handles.slider_frame)
    return
  end
  f = round(get(handles.slider_frame, 'Value'));
  str{end+1} = '--- Class Counts ---';
  tmp = 'Class : ';
  if ~isempty(G_VIEWER.pred)
    tmp = [tmp ' pred (std) '];
  end
  if ~isempty(G_VIEWER.truth)
    tmp = [tmp ' [truth]'];
  end
  str{end+1} = tmp;
  for j=1:length(G_OPT.dirs)
    tmp = ['Class ' G_OPT.dirs{j} ' : '];
    if ~isempty(G_VIEWER.pred)
      if ~isempty(G_VIEWER.pred{j}.pred)
	tmp = [tmp sprintf('%d ', round(G_VIEWER.pred{j}.pred(f)))];
      end
      if ~isempty(G_VIEWER.pred{j}.predvar)
	tmp = [tmp sprintf('(%0.1f) ', sqrt(G_VIEWER.pred{j}.predvar(f)))];
      end
    end
    if ~isempty(G_VIEWER.truth)
      jj = find(strcmp(G_OPT.dirs{j}, G_VIEWER.truth.dir));
      tmp = [tmp sprintf('[%d]', G_VIEWER.truth.count{jj}(f))];
    end
    str{end+1} = tmp;
  end
end

set(handles.text_info, 'String', str);
  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ROI FUNCTIONS 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% get the ROI
function markroi(handles)
global G_VIEWER
[roimask, xi, yi] = getroi();

% save structure
roi.xi   = xi;
roi.yi   = yi;
roi.mask = roimask;

% save output
G_VIEWER.output = roi;

% update image
G_VIEWER.roi = roi.mask;
make_image(handles);
draw_image(handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% PMAP FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% make perspective map
function markpmap(handles, mode)
global G_VIEWER_INT G_VIEWER

if (strcmp(G_VIEWER.mode, 'pmap'))
  switch (mode)
    case 'gndbox'
      [rmask, xi, yi] = getroi();
      xi = xi(1:end-1); % remove duplicate point
      yi = yi(1:end-1);
      if length(xi) ~= 4
        h = errordlg('ground box must have only 4 corners');
        uiwait(h);
      else
        % reorder so bottom-left is first, and going counter-clockwise
        [syi, ii] = sort(yi);
        sxi = xi(ii);
        tmp = [];
        if (sxi(3) < sxi(4))
          tmp = [syi(3) sxi(3); syi(4) sxi(4)];
        else
          tmp = [syi(4) sxi(4); syi(3) sxi(3)];
        end
        if (sxi(1) < sxi(2))
          tmp = [tmp; syi(2) sxi(2); syi(1) sxi(1)];
        else
          tmp = [tmp; syi(1) sxi(1); syi(2) sxi(2)];
        end
        G_VIEWER_INT.pmap.gndbox = tmp;
      end
    case 'nearbox'
      [rmask, xi, yi] = getroi();
      if (length(xi)<=2)
        h = errordlg('reference box should have at least 2 points!');
        uiwait(h);
      else
        G_VIEWER_INT.pmap.nearbox = [yi xi];
        G_VIEWER_INT.pmap.nearframe = get(handles.slider_frame, 'Value');
      end
    case 'farbox'
      [rmask, xi, yi] = getroi();
      if (length(xi)<=2)
        h = errordlg('reference box should have at least 2 points!');
        uiwait(h);
      else
        G_VIEWER_INT.pmap.farbox = [yi xi];
        G_VIEWER_INT.pmap.farframe = get(handles.slider_frame, 'Value');
      end
  end
  
  % if everything is valid, then compute the map
  if ~isempty(G_VIEWER_INT.pmap.farbox) && ...
      ~isempty(G_VIEWER_INT.pmap.nearbox) && ...
      ~isempty(G_VIEWER_INT.pmap.gndbox)
    
    % [y,x] coordinates of the ground-plane:
    %
    %         d--------c
    %        /        /
    %       /        /
    %      /        /
    %      a--------b
    %
    % get points
    a = G_VIEWER_INT.pmap.gndbox(1,:);
    b = G_VIEWER_INT.pmap.gndbox(2,:);
    c = G_VIEWER_INT.pmap.gndbox(3,:);
    d = G_VIEWER_INT.pmap.gndbox(4,:);
    
    % the reference height of a person on line "ab"
    refy_close = max(G_VIEWER_INT.pmap.nearbox(:,1)) - min(G_VIEWER_INT.pmap.nearbox(:,1));
    % the reference height of the same person on line "cd"
    refy_far   = max(G_VIEWER_INT.pmap.farbox(:,1)) - min(G_VIEWER_INT.pmap.farbox(:,1));
    
    % x-distance between a and b
    refx = b(2)-a(2);

    % compute the perspective map
    pmapx = zeros(size(G_VIEWER.img,1), size(G_VIEWER.img,2));
    pmapy = pmapx;
    
    % for each line...
    for y=1:size(G_VIEWER.img,1)
      % compute the distance between "ad" and "bc" at this y
      fx = ((y-b(1)) / (c(1)-b(1))) * (c(2)-b(2)) + b(2);
      ex = ((y-a(1)) / (d(1)-a(1))) * (d(2)-a(2)) + a(2);
      x = fx-ex;
  
      % inverse of the relative width of x to the "ab"
      pmapx(y,:) = refx/x;
      
      % interpolate the reference height in y
      py = (refy_close-refy_far)/(a(1)-c(1))*(y-c(1)) + refy_far;
      
      % inverse of the relative height of py to the reference height
      pmapy(y,:) = refy_close/py;
    end
    
    % multiply pmapy and pmapx to get the perspective map
    pmap2 = pmapx.*pmapy;
    G_VIEWER_INT.pmap.pmapxy = pmap2;
    G_VIEWER_INT.pmap.pmapx  = pmapx;
    G_VIEWER_INT.pmap.pmapy  = pmapy;
    
    % set output
    G_VIEWER.output = G_VIEWER_INT.pmap;
  end
end

% update image
draw_image(handles);

if strcmp(mode, 'view')
  % make a plot showing everything
  tmp = G_VIEWER_INT.pmap.gndbox;
  tmp(end+1,:) = tmp(1,:);

  h = figure;
  subplot(2,2,1)
  image(G_VIEWER.img(:,:,G_VIEWER_INT.pmap.nearframe));
  hold on
  colormap(gray(256))
  plot(tmp(:,2), tmp(:,1), '.r-');
  plot(G_VIEWER_INT.pmap.nearbox(:,2), G_VIEWER_INT.pmap.nearbox(:,1), 'r');
  hold off
  axis image
  title('near reference');
  subplot(2,2,2)
  image(G_VIEWER.img(:,:,G_VIEWER_INT.pmap.farframe));
  hold on
  colormap gray
  plot(tmp(:,2), tmp(:,1), '.r-');
  plot(G_VIEWER_INT.pmap.farbox(:,2), G_VIEWER_INT.pmap.farbox(:,1), 'r');
  hold off
  axis image
  title('far reference');

  subplot(2,2,3)
  image(G_VIEWER.img(:,:,G_VIEWER_INT.pmap.nearframe));
  axis image
  hold on
  [cc, ch] = contour(G_VIEWER_INT.pmap.pmapxy, [1 2 3 4 5], 'r:');
  set(ch, 'linewidth', 1);
  set(ch, 'linestyle', ':');
  cc2 = unique(cc(2,:));
  myfont = 18;
  for i=1:length(cc2)
    if (cc2(i) < size(G_VIEWER.img,1))
      text(size(G_VIEWER.img,2)+2, cc2(i), ...
        sprintf('%d', round(G_VIEWER_INT.pmap.pmapxy(round(cc2(i)),1))), ...
        'color', [1 0 0], 'fontsize', myfont-8)
    end
  end
  hold off
  title('perspective contours');
  
  subplot(2,2,4)
  imagesc(G_VIEWER_INT.pmap.pmapxy);
  axis image
  hold on
  [cc, ch] = contour(G_VIEWER_INT.pmap.pmapxy, [1 2 3 4 5], 'r:');
  set(ch, 'linewidth', 1);
  set(ch, 'linestyle', ':');
  cc2 = unique(cc(2,:));
  myfont = 18;
  for i=1:length(cc2)
    if (cc2(i) < size(G_VIEWER.img,1))
      text(size(G_VIEWER.img,2)+2, cc2(i), ...
        sprintf('%d', round(G_VIEWER_INT.pmap.pmapxy(round(cc2(i)),1))), ...
        'color', [1 0 0], 'fontsize', myfont-8)
    end
  end
  hold off
  title('perspective map');
  
  uiwait(h);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% SEGM MAP FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function updateSegmMap(handles, incr)
global G_VIEWER_INT G_VIEWER
i = G_VIEWER_INT.segm.cur + incr;
if (i > G_VIEWER_INT.segm.len)
  i = 1;
end
if (i < 1)
  i = G_VIEWER_INT.segm.len;
end
G_VIEWER_INT.segm.cur = i;
p = G_VIEWER_INT.segm.map(i,1);
G_VIEWER.segm = uint8(G_VIEWER_INT.segm.segmold == p);

set(handles.popup_multi5, 'Value', G_VIEWER_INT.segm.map(i,2)+1);
updateSegmText(handles);

% enable/disable buttons
if (i == 1)
  set(handles.button_multi3, 'Enable', 'off');
else
  set(handles.button_multi3, 'Enable', 'on');
end
if (i == G_VIEWER_INT.segm.len)
  set(handles.button_multi2, 'Enable', 'off');
else
  set(handles.button_multi2, 'Enable', 'on');
end
  
function updateSegmText(handles)
global G_VIEWER_INT
mymap = G_VIEWER_INT.segm.map;
instructions = {'Label each segment with the popup menu.', ...
  '', ...
  'Current Map:'};
tmpstr = get(handles.popup_multi5, 'String');
for i=1:size(mymap,1)
  instructions{end+1} = sprintf('pixel %d ==> %s', mymap(i,1), tmpstr{mymap(i,2)+1});
end
instructions{end+1} = '';
instructions{end+1} = sprintf('Segment value = %d', mymap(G_VIEWER_INT.segm.cur,1));
instructions{end+1} = 'Which class is this segment?';
set(handles.text_info, 'String', instructions);

function outputSegmMap()
global G_VIEWER_INT G_VIEWER

G_VIEWER.output.segm = G_VIEWER_INT.segm.segmold;
for i=1:G_VIEWER_INT.segm.len
  pold = G_VIEWER_INT.segm.map(i,1);
  pnew = G_VIEWER_INT.segm.map(i,2);
  ii = find(G_VIEWER_INT.segm.segmold == pold);
  G_VIEWER.output.segm(ii) = pnew;
end

G_VIEWER.output.segmmap = G_VIEWER_INT.segm.map;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% TRUTH FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function updateTruth(handles, mode, arg1)
global G_VIEWER_INT
f = get(handles.slider_frame, 'Value');
c = get(handles.popup_multi5, 'Value');
switch(mode)
  case 'add'
    G_VIEWER_INT.rawlocs{c,f} = [G_VIEWER_INT.rawlocs{c,f}; arg1(1) arg1(2)];
  case 'undo'
    if ~isempty(G_VIEWER_INT.rawlocs{c,f})
      G_VIEWER_INT.rawlocs{c,f}(end,:) = [];
    end
  case 'clear'
    G_VIEWER_INT.rawlocs{c,f} = [];
  case 'copy'
    if (f ~= 1)
      G_VIEWER_INT.rawlocs{c,f} = G_VIEWER_INT.rawlocs{c,f-1};
    end
end
updateTruthText(handles);
draw_image(handles);

function updateTruthText(handles)
global G_VIEWER_INT
f = get(handles.slider_frame, 'Value');
%v = get(handles.popup_multi5, 'Value');
str = get(handles.popup_multi5, 'String');
txt = {};
txt{end+1} = 'Count people in each class by clicking on them.';
txt{end+1} = 'Change the class using the popup menu';
txt{end+1} = '';
txt{end+1} = sprintf('Count in Frame %d:', f);
for i=1:size(G_VIEWER_INT.rawlocs,1)
  txt{end+1} = [str{i} ' = ' sprintf('%d', size(G_VIEWER_INT.rawlocs{i,f},1))];
end
set(handles.text_info, 'String', txt);

function outputTruth()
global G_VIEWER_INT G_VIEWER G_OPT
% count, and interpolate between marked frames
G_VIEWER.output.count = cell(1,length(G_OPT.dirs));
for f=3:5:G_VIEWER_INT.numframes
  for j=1:length(G_OPT.dirs)
    % count
    mycount = size(G_VIEWER_INT.rawlocs{j,f},1);
    % interpolate
    ff = f+(-2:2);
    ii = find( (ff>=1).*(ff<=G_VIEWER_INT.numframes) );
    G_VIEWER.output.count{j}(ff(ii)) = mycount;
  end
end

%% BUG FIX: 2009-04-13: fill in remaining frames
for j=1:length(G_OPT.dirs)
  tmp = G_VIEWER_INT.numframes - length(G_VIEWER.output.count{j});
  if (tmp ~= 0)
    G_VIEWER.output.count{j} = [G_VIEWER.output.count{j}, ...
                                G_VIEWER.output.count{j}(end)*ones(1,tmp)];
  end
end

G_VIEWER.output.dir = G_OPT.dirs;
G_VIEWER.output.rawlocs = G_VIEWER_INT.rawlocs;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% MISC FUNCTIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% get ROI
function [roimask, xi, yi] = getroi()
if exist('roipolyold')
  warning off
  [roimask, xi, yi] = roipolyold();
  warning on
else
  [roimask, xi, yi] = roipoly();
end


function doclose()
global G_VIEWER_INT
% stop playing
G_VIEWER_INT.is_playing = 0;
% free memory
G_VIEWER_INT.cimg = [];
G_VIEWER_INT.pmap = [];
G_VIEWER_INT.segm = [];
G_VIEWER_INT.rawlocs = [];
closereq;

function []=axisremove()
% axisremove - remove the ticks and numbers from both axis
set(gca, 'XTickLabel', '');
set(gca, 'XTick', []);
set(gca, 'YTickLabel', '');
set(gca, 'YTick', []);

function [rgb] = gray2rgbm(y)
% gray2rgbm - convert gray movie to RGB gray movie
%
%    rgb = gray2rgbm(y)
%

v = version;
if (v(1) == '6')
  rgb = repmat(uint8(0), [size(y,1) size(y,2) 3 size(y,3)]);
else
  rgb = zeros([size(y,1) size(y,2) 3 size(y,3)], 'uint8');
end

for n=1:size(y,3)
  rgb(:,:,1,n) = y(:,:,n);
  rgb(:,:,2,n) = y(:,:,n);
  rgb(:,:,3,n) = y(:,:,n);
end

