opt = read_opt([0 0 0 0]);
fname = [opt.evalpref '_' opt.dirs{1} '_eval' sprintf('%d.mat', opt.evalnum)];
fprintf('loading eval %s.\n', fname);
tmp = load(fname);
results{1}.stats  = tmp.results.stats;
results{1}.rstats = tmp.results.rstats;
results{1}.data   = tmp.results.data;

cnt = [];
cnt(results{1}.data.trainset)  = results{1}.data.cnttrain;
cnt(results{1}.data.testset)   = results{1}.data.cnttest;
cnt(results{1}.data.trainset2) = results{1}.data.cnttrain2;
pred = [];
pred(results{1}.data.trainset)  = results{1}.data.predtrain;
pred(results{1}.data.testset)   = results{1}.data.predtest;
pred(results{1}.data.trainset2) = results{1}.data.predtrain2;
predvar = [];
if ~isempty(results{1}.data.predvartrain)
  predvar(results{1}.data.trainset)  = results{1}.data.predvartrain;
end
if ~isempty(results{1}.data.predvartest)
  predvar(results{1}.data.testset)   = results{1}.data.predvartest;
end
if ~isempty(results{1}.data.predvartrain2)
  predvar(results{1}.data.trainset2) = results{1}.data.predvartrain2;
end
md = zeros(1,length(cnt));
md(results{1}.data.trainset)  = 1;
md(results{1}.data.trainset2) = 2;
md(results{1}.data.testset)   = 3;

% plot
figure;
hold on;
stairs(cnt, 'k-');
stairs(round(pred), 'b-', 'LineWidth', 2.0);
tmp = find(md==1);
plot(tmp, 0*ones(1,length(tmp)), 'g.');
tmp = find(md==3);
plot(tmp, 0*ones(1,length(tmp)), 'r.');
grid;
%ylim([0 40]);
ylabel('count');
xlabel('frame');
myleg = {'truth', 'prediction', 'training set', 'test set'};
legend(myleg, 2);