% gp_kernels - summary of kernels for GP regression
%
% name       logtheta                      k(x^p,x^q)
% -------------------------------------------------------
% covConst   [log(sqrt(s2))]               1/s2
% covLINard  [log(L(1:D))]                 x^p'*inv(P)*x^q,         P = diag(L(1:D)^2)
% covLINone  [log(sqrt(t2))]               x^p'*inv(P)*x^q + 1/t2,  P=t2*I
%            [-log(sqrt(s2))]              s2*(x^p'*x^q + 1)
% covNoise   [log(sqrt(s2))]               s2*delta(p,q)
% covSEard   [log(L(1:D)) log(sqrt(sf2))]  sf2*exp(-(x^p-x^q)'*inv(P)*(x^p-x^q)/2), P=diag(L(1:D)^2)
% covSEiso   [log(L) log(sqrt(sf2))]       sf2*exp(-(x^p-x^q)'*inv(P)*(x^p-x^q)/2), P=L^2 *I
%
% covPolyiso [log(sqrt(t2)) log(d)]        (x^p'*inv(P)*x^q + 1./t2)^d, P=t2*I
% 
% covProd
% covSum
%
% covMatern3iso
% covMatern5iso
% covNNone
% covPeriodic
% covRQard
% covRQiso
%
% see "help covFunctions" for more details
