function [Ypred] = lin_predict(X, lm)
% lin_predict - predict with linear regression
%
%   [Ypred] = lin_predict(X, lm)
%
%       X = feature vectors (each column is a feature vector)
%      lm = linear model trained with lin_train
%
%   Ypred = Y predictions
%
% Copyright 2008, Antoni Chan, SVCL, UCSD


% add ones
XX = [ones(1,size(X,2)); X];

% predict
Ypred = lm.b'*XX;



