function lm = lin_train(X, Y)
% lin_train - train a linear regression model
%
%    lm = lin_train(X, Y)
% 
%         X = feature vectors (each column is a feature vector)
%         Y = function values
%
%  Note: this uses the Matlab function "regress"
%
% Copyright 2008, Antoni Chan, SVCL, UCSD


% add vector of ones
XX = [ones(1,size(X,2)); X];

[b, bint, r, rint, stats] = regress(Y(:), XX');

lm.b     = b;
lm.bint  = bint;
lm.r     = r;
lm.rint  = rint;
lm.stats = stats;
