function [Ypred] = rob_predict(X, lm)
% rob_predict - predict with robust linear regression
%
%   [Ypred] = rob_predict(X, rb)
%
%       X = feature vectors (each column is a feature vector)
%      rb = linear model trained with rob_train
%
%   Ypred = Y predictions
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

XX = [ones(1,size(X,2)); X];

% predict
Ypred = lm.b'*XX;



