function Ypred = rvm_predict(X, rvm)
% rvm_predict - predict using an RVM
%
%    Ypred = rvm_predict(X, rvm)
%
%       X = feature vectors (each column is a feature vector)
%     rvm = RVM trained with rvm_train
%
%   Ypred = predictions
%
% This uses the RVM code by Mike Tipping.
%
% Copyright 2008, Antoni Chan, SVCL, UCSD


% Evaluate the model over the training data
PHI     = sbl_kernelFunction(X', rvm.Xused', rvm.kernel, rvm.width);
Ypred   = PHI*rvm.weights;
Ypred   = Ypred';

if isfield(rvm, 'Ymean') && ~isempty(rvm.Ymean)
  Ypred = Ypred + rvm.Ymean;
end

