function yp = svrl_predict(X, mysvr)
% svrl_predict - predict with SVR regression
%
%   yp = svrl_predict(X,svr)
%
%   INPUT
%       X = feature vectors (each column is a feature vector)
%     svr = SVR trained with svrl_train
%
%  OUTPUT
%      yp = predictions
%
% This function uses the SVMlight library.
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

fname = sprintf('/tmp/svml_%d.model', round(rand*1000000));

mysvr.fname = fname;
fid         = fopen(fname,'w');
fwrite(fid, mysvr.model, 'char');
fclose(fid);

yp = svmlfwd(mysvr, X');
yp = yp';

% clean up
delete(fname);
