clear
close all

addpath ~/peoplecnt/lib

nums = 0:9;
opt.mode      = 'eval';
opt.recompute = 0;
opt.debug     = 1;
opt.basedir   = '/data2/vidtex/vidtexseg/ucsdpeds_vidf';
if 0
for i=1:length(nums)
  opt.imgnames{i}  = sprintf('Data/vidf1_33_%03d.y', nums(i));
  opt.segmnames{i} = sprintf('results/vidf1_33_%03d.y/dytexmix/vidf1_33_%03d.y_dtm_7W_7W_20W_4T_4T_10T_-10V_2N_10n_2K_0.5Qr_0.5Sr_0.5Rr_split_Qp_C_2T_2T_2T_cont_post5.segm', nums(i), nums(i));
  opt.featpref{i}  = sprintf('features/vidf1_33_%03d.y/dytexmix/vidf1_33_%03d.y_dtm_7W_7W_20W_4T_4T_10T_-10V_2N_10n_2K_0.5Qr_0.5Sr_0.5Rr_split_Qp_C_2T_2T_2T_cont_post5.segm.roi_mainwalkway.dmap3', nums(i), nums(i));
  opt.truthname{i} = sprintf('MetaData/vidf1_33_%03d_count_2K_roi_mainwalkway.mat', nums(i));
  opt.predpref{i}  = sprintf('results_cnt/vidf1_33_%03d.y_dtm_2K_model_test4_block3_800', nums(i));
end
opt.modelpref = 'models/model_test4_block3_800';
opt.evalpref = 'results_cnt/eval_test4_block3_800';
else
  opt.mode = 'predict';
  nums = 10:15;
  for i=1:length(nums)
    opt.imgnames{i}  = sprintf('Data/vidf1_33_%03d.y', nums(i));
    opt.segmnames{i} = sprintf('results/vidf1_33_%03d.y/dytexmix/vidf1_33_%03d.y_dtm_7W_7W_20W_4T_4T_10T_-10V_2N_10n_2K_0.5Qr_0.5Sr_0.5Rr_split_Qp_C_2T_2T_2T_cont_post5.segm', nums(i), nums(i));
    opt.featpref{i}  = sprintf('features/vidf1_33_%03d.y/dytexmix/vidf1_33_%03d.y_dtm_7W_7W_20W_4T_4T_10T_-10V_2N_10n_2K_0.5Qr_0.5Sr_0.5Rr_split_Qp_C_2T_2T_2T_cont_post5.segm.roi_mainwalkway.dmap3', nums(i), nums(i));
    opt.truthname{i} = '';
    opt.predpref{i}  = sprintf('results_cnt/vidf1_33_%03d.y_dtm_2K_model_test4_block3_800', nums(i));
  end
  opt.modelpref = 'models/model_test4_block3_800';
  opt.evalpref = 'results_cnt/eval_test4_block3_800';
end

opt.segmmapname  = 'MetaData/vidf1_33_segmmap_cont.mat';
opt.roiname  = 'MetaData/vidf1_33_roi_mainwalkway.mat';
opt.pmapname = 'MetaData/vidf1_33_dmap3.mat';
opt.evalname = 'MetaData/EvalSet_block3_800.mat';
opt.evalnum  = [1];
opt.dirs     = {'r', 'l'}; 

opt.feature{1}.name = 'norm_area';
opt.feature{1}.opt  = [];
opt.feature{1}.sub  = [];
opt.feature{2}.name = 'norm_perimeter';
opt.feature{2}.opt  = [];
opt.feature{2}.sub  = [];
opt.feature{3}.name = 'norm_perimeterorient';
opt.feature{3}.opt  = 6;
opt.feature{3}.sub  = [];
opt.feature{4}.name = 'norm_paratio';
opt.feature{4}.opt  = [];  
opt.feature{4}.sub  = [];
if 1
opt.feature{5}.name = 'norm_edge';
opt.feature{5}.opt  = [];
opt.feature{5}.sub  = [];
opt.feature{6}.name = 'norm_edgeorient';
opt.feature{6}.opt  = 6;
opt.feature{6}.sub  = [];
opt.feature{7}.name = 'norm_edgeminkowski';
opt.feature{7}.opt  = [];  
opt.feature{7}.sub  = [];
opt.feature{8}.name = 'norm_glcm';
opt.feature{8}.opt  = 'f';  
opt.feature{8}.sub  = [3 4 5,8 9 10,13 14 15,18 19 20];
end

opt.model.name = 'gp';
opt.model.param.covfunc = {'covSum',{'covSEiso','covLINone','covNoise'}};
opt.model.param.normmode  = 'y';
opt.model.param.numtrials = 1;
opt.model.norm = 'X';


% peoplecnt(opt)
