function [roi] = util_make_roi(img)
% make_roi - tool to create a ROI
%
%   roi = make_roi(img)
%
%      img - image to show
%
% Copyright 2008, Antoni Chan, SVCL, UCSD

% show the image
figure
imagesc(img);
colormap gray;
axis image

% get the ROI
fprintf('mark the ROI using mouse.\nclick to add vertex.\nshift-click to add final vertex\nenter finished without adding vertex\n');

[roimask, xi, yi] = roipoly;

% save structure
roi.xi   = xi;
roi.yi   = yi;
roi.mask = roimask;

% show the ROI
figure
tmp = img.*(roi.mask/2 + 0.5);
imagesc(tmp);
colormap gray



